# Class ContentCoding

java.lang.Object
uk.ac.starlink.util.ContentCoding

All Implemented Interfaces:
  `uk.ac.starlink.auth.UrlConnector`

public abstract class ContentCoding extends Object implements uk.ac.starlink.auth.UrlConnector
Defines a policy for Content Codings used in HTTP connections. An instance of this class is used to prepare requests and decode responses for some HTTP-based communications in this package. It controls whether HTTP-level content codings are used; typically this means transparent gzip compression of the HTTP response stream where negotiation indicates it is allowed.

Two static instances `NONE` and `GZIP` are provided. It should be completely safe to use either of these in any context, since an instance of this class represents only an indication to an HTTP server that a particular coding scheme is supported by the client. A service is therefore always at liberty to ignore this hint/request and provide and unencoded response if, for instance, it does not support the requested compression scheme. Good practice for use of this class is therefore probably to use GZIP where the response is expected to be large and reasonably compressible (a long VOTable is a good example), and NONE where the response is expected to be short or, especially, not very gzippable (for instance noisy binary floating point data, or a byte stream that has already been compressed).

The provided instances also include some logging functionality; information about how many bytes (and where applicable the level of compression) is logged for bytestreams read through these instances. The logging level for this information is currently CONFIG.

See Also:
  - RFC 2616 secs 3.5, 14.3, 14.11

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`ACCEPT_ENCODING`
Name of HTTP request header to request coded response ("Accept-Encoding").
`static final String`
`CONTENT_ENCODING`
Name of HTTP response header to mark coded response ("Content-Encoding").
`static final ContentCoding`
`GZIP`
Gzip encoding is requested.
`static final ContentCoding`
`NONE`
No encoding is requested.

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`ContentCoding()`
Constructor.

## Method Summary

Modifier and Type
Method
Description
`void`
`connect(HttpURLConnection hconn)`
`abstract InputStream`
`getErrorStream(URLConnection conn)`
Returns the error stream response from the given connection, which was prepared using this object's `prepareRequest` method.
`abstract InputStream`
`getInputStream(URLConnection conn)`
Returns the input stream response from the given connection, which was prepared using this object's `prepareRequest` method.
`URLConnection`
`openConnection(URL url)`
Convenience method to open a new connection prepared in accordance with this object's encoding policy.
`InputStream`
`openStream(URL url)`
Convenience method to return a byte stream from a given URL in accordance with this object's encoding policy.
`InputStream`
`openStreamAuth(URL url, uk.ac.starlink.auth.AuthManager authManager)`
Convenience method to return a byte stream from a given URL in accordance with this object's encoding policy and with authentication and redirects handled by a given AuthManager (typically `AuthManager.getInstance()`).
`abstract void`
`prepareRequest(URLConnection conn)`
Sets up request headers for the given connection.

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### NONE

public static final ContentCoding NONE
No encoding is requested.

### GZIP

public static final ContentCoding GZIP
Gzip encoding is requested.

### ACCEPT_ENCODING

public static final String ACCEPT_ENCODING
Name of HTTP request header to request coded response ("Accept-Encoding").

See Also:
  - Constant Field Values

### CONTENT_ENCODING

public static final String CONTENT_ENCODING
Name of HTTP response header to mark coded response ("Content-Encoding").

See Also:
  - Constant Field Values

## Constructor Details

### ContentCoding

protected ContentCoding()
Constructor.

## Method Details

### prepareRequest

public abstract void prepareRequest(URLConnection conn)
Sets up request headers for the given connection. The connection must not have yet been connected.

Parameters:
  `conn` - unconnected connection

### getInputStream

public abstract InputStream getInputStream(URLConnection conn) throws IOException
Returns the input stream response from the given connection, which was prepared using this object's `prepareRequest` method. Any required decoding will have been done transparently.

Parameters:
  `conn` - connection
Returns:
  stream decoded as required
Throws:
  `IOException`
See Also:
  - `URLConnection.getInputStream()`

### getErrorStream

public abstract InputStream getErrorStream(URLConnection conn) throws IOException
Returns the error stream response from the given connection, which was prepared using this object's `prepareRequest` method. Any required decoding will have been done transparently.

Parameters:
  `conn` - connection
Returns:
  stream decoded as required
Throws:
  `IOException`
See Also:
  - `URLConnection.getInputStream()`

### openConnection

public URLConnection openConnection(URL url) throws IOException
Convenience method to open a new connection prepared in accordance with this object's encoding policy. Opens the connection and calls `prepareRequest`.

Parameters:
  `url` - target URL
Returns:
  prepared connection
Throws:
  `IOException`

### openStream

public InputStream openStream(URL url) throws IOException
Convenience method to return a byte stream from a given URL in accordance with this object's encoding policy. Opens the connection, prepares the request, and decodes the result.

Parameters:
  `url` - target URL
Returns:
  unencoded stream from the URL
Throws:
  `IOException`

### openStreamAuth

public InputStream openStreamAuth(URL url, uk.ac.starlink.auth.AuthManager authManager) throws IOException
Convenience method to return a byte stream from a given URL in accordance with this object's encoding policy and with authentication and redirects handled by a given AuthManager (typically `AuthManager.getInstance()`).

Parameters:
  `url` - target URL
  `authManager` - authentication manager
Returns:
  unencoded stream from the URL
Throws:
  `IOException`

### connect

public void connect(HttpURLConnection hconn) throws IOException

Specified by:
  `connect` in interface `uk.ac.starlink.auth.UrlConnector`
Throws:
  `IOException`